// PentagramBox.cpp

#include "StdAfx.h"

#include "PentagramBox.h"

using namespace Test7;

PentagramBox::PentagramBox(Control ^parent, Rectangle bounds)
{
  Parent = parent;
  Bounds = bounds;
  pent = gcnew Pentagram(Point(bounds.Width / 2, bounds.Height / 2), Math::Min(bounds.Width / 2, bounds.Height / 2));
  dragging = false;
}

void PentagramBox::OnPaint(PaintEventArgs ^pe)
{
  __super::OnPaint(pe);
  pent->Draw(pe->Graphics);
}

void PentagramBox::OnMouseDown(MouseEventArgs ^e)
{
  if (e->Button == Forms::MouseButtons::Left) {
    dragging = true;
    lastmousepos = e->Location;
  }
  __super::OnMouseDown(e);
}

void PentagramBox::OnMouseUp(MouseEventArgs ^e)
{
  if (e->Button == Forms::MouseButtons::Left) dragging = false;
  __super::OnMouseUp(e);
}

void PentagramBox::OnMouseMove(MouseEventArgs ^e)
{
  if (dragging) {
    Drawing::Size movevect(e->Location.X - lastmousepos.X, e->Location.Y - lastmousepos.Y);
    Location += movevect;
  }
  __super::OnMouseMove(e);
}
